.initMethods.strLattice <- function(where) {
}

logLik.aglm <- function(object, ...) {
  res <- object$logLik
  attr(res, "df") <- object$npars
  class(res) <- "logLik"
  res
}
extractAIC.aglm <- function(fit, scale, k=2, ...) {
  r <- logLik(fit, ...)
  return(as.numeric(c(attr(r, "df"),-attr(r,'df')*r + k*attr(r, "df"))))
}

AIC.aglm <- function(object, ..., k = 2) 
  as.numeric(extractAIC(object, scale, k=k, ...))[2]
  
  print.aglm <- function(x, ...) {
    cat("Fitted coefficients:\n")
    print(x$coefficients)
    if (!is.null(x$boot))
      cat("Number of bootstraps:", nrow(x$boot), "\n")
    if (!is.null(x$mc))
      cat("Number of Monte Carlo simulations:", nrow(x$mc), "\n")
    return(invisible())
  }
  
terms.aglm <- function(x, ...) terms(x$formula)


summary.aglm <- function(object, ...) {
    res <- list()
    if (!is.null(object$naive))
      res$naive <- coef(summary(object$naive))
    if (!is.null(object$optim.res)) {
      m <- object$optim.res$par
      sd <- sqrt(diag(solve(object$optim.res$hessian)))
      z <- m/sd
      p <- 2*pnorm(abs(z), lower=FALSE)
      res$fit=data.frame(estimate=m, "Std.Error."=sd,
        "z-value"=z, "p-value"=p)
    }
    if (!is.null(object$boot)) {
      m <- colMeans(object$boot)
      sd <- apply(object$boot, 2, sd)
      z <- m/sd
      p <- 2*pnorm(abs(z), lower=FALSE)
      res$boot <- data.frame(estimate=m, "Boot.Std.Error."=sd,
                             "z-value"=z, "p-value"=p)
    }
    if (!is.null(object$mc)) {
      m <- coef(object$naive)
      p <- mean(abs(object$mc[,1])>abs(m[1]))
      for (i in 2:length(m))
        p <- c(p, mean(abs(object$mc[,i])>abs(m[i])))
      res$"mc.p-value" <- p
    }
    return(res)
  }
