snrl2 <- function(sp, data) {
  data[is.na(data)] <- 0
  dd <- dim(data)
  cterm <- strsplit(as.character(sp)[3], " ")[[1]]
  res <- list()
  if (any(cterm=="S"))
    res$S <- data
  if (any(cterm=="R"))
    res$R <- cbind(0, data[, -dd[2]]) + cbind(data[, -1], 0)
  if (any(cterm=="C"))
    res$C <- rbind(0, data[-dd[1], ]) + rbind(data[-1, ], 0)
  if (any(cterm=="first")) 
    res$first <- cbind(0, data[, -dd[2]]) + cbind(data[, -1], 0) +
      rbind(0, data[-dd[1], ]) + rbind(data[-1, ], 0)
  if (any(cterm=="dA"))
    res$dA <- rbind(0, cbind(0, data[-dd[1], -dd[2]])) +
      rbind(cbind(data[-1, -1], 0), 0)
  if (any(cterm=="dB"))
    res$dB <- rbind(0, cbind(data[-dd[1], -1], 0)) +
      rbind(cbind(0, data[-1, -dd[2]]), 0)
  if (any(cterm=="D"))
    res$D <- rbind(0, cbind(0, data[-dd[1], -dd[2]])) +
      rbind(cbind(data[-1, -1], 0), 0) +
        rbind(0, cbind(data[-dd[1], -1], 0)) +
          rbind(cbind(0, data[-1, -dd[2]]), 0)
  if (any(cterm=="second"))
    res$second <- cbind(0, data[, -dd[2]]) + cbind(data[, -1], 0) +
      rbind(0, data[-dd[1], ]) + rbind(data[-1, ], 0) +
        rbind(0, cbind(0, data[-dd[1], -dd[2]])) +
          rbind(cbind(data[-1, -1], 0), 0) +
            rbind(0, cbind(data[-dd[1], -1], 0)) +
              rbind(cbind(0, data[-1, -dd[2]]), 0)
  for (i in 1:length(res)) 
    dimnames(res[[i]]) <- dimnames(data)
  return(res)
}

snrl3 <- function (sp, data, lag) {
  ddd <- dim(data)
  if (length(ddd) < 3) 
    return(sapply(snrl2(sp, data), as.numeric))
  else {
    spterms <- attr(terms(sp), "term.labels")
    nr <- prod(ddd[1:2])
    res <- matrix(NA, nr*ddd[3], length(spterms),         
                  dimnames=list(NULL, paste(as.character(sp)[[2]],
                    spterms, lag, sep=".")))
    if ((ddd[3]+lag)>0)
      for (i in 1:(ddd[3]+lag)) 
        res[1:nr+(i-lag-1)*nr, ] <- sapply(snrl2(sp, data[, , i]), as.numeric)
  }
  return(res)
}

